#include <unistd.h>
#include <fcntl.h>
#include <pthread.h> 

pthread_t thr_writer1; 
pthread_t thr_writer2; 
pthread_mutex_t mtx_lock;
 
int g_counter = 0;

const int dot = 46; /* ASCII code for period */
const int newline = 10; /* ASCII code for new line */

void *print_dots() { 

	pthread_mutex_lock(&mtx_lock); 

     while (g_counter < 25) {
          g_counter++;
          for (int i = 0; i < g_counter; i++)
              write(STDOUT_FILENO, &dot, 1);
          write(STDOUT_FILENO, &newline, 1); 
     }  

	pthread_mutex_unlock(&mtx_lock); 

     pthread_exit(NULL);

} 

int main(void) { 

     int thread_return;

	if (pthread_mutex_init(&mtx_lock, NULL) != 0)  
		return(1); 

     thread_return = pthread_create(&thr_writer1, NULL, print_dots, NULL);
     if (thread_return != 0) 
          return(thread_return);

     thread_return = pthread_create(&thr_writer2, NULL, print_dots, NULL);
     if (thread_return != 0) 
          return(thread_return); 

	pthread_join(thr_writer1, NULL); 
	pthread_join(thr_writer2, NULL); 

	pthread_mutex_destroy(&mtx_lock); 

	return 0; 
} 

